/*
 *
 * Copyright (c) 2015 SSS
 *
*/

#include "xparameters.h"
#include "xil_cache.h"
#include "backward_ip_axiw.h"

// Define delay length
#define DELAY 10

int main(){

	int x, phi, y, bw, alpha;
	int i, i1, i2, np;
	double inc;

	np = 40;
	inc = 1023./np;

	xc_iface_t *iface;
	xc_to_reg_t *toreg_in1;
	xc_to_reg_t *toreg_in2;
	xc_to_reg_t *toreg_in3;
	xc_from_reg_t *fromreg1;
	xc_from_reg_t *fromreg2;
	
	// initialize the software driver
	xc_create(&iface, &BACKWARD_IP_AXIW_ConfigTable[0]);
	
	xc_get_shmem(iface, "x", (void **) &toreg_in1);
	xc_get_shmem(iface, "phi", (void **) &toreg_in2);
	xc_get_shmem(iface, "y", (void **) &toreg_in3);
	xc_get_shmem(iface, "bw", (void **) &fromreg1);
	xc_get_shmem(iface, "alpha", (void **) &fromreg2);
	
    Xil_ICacheEnable();
    Xil_DCacheEnable();

	//xil_printf("Starting...\r\n");
	
	y = 512;
	for (i1=0; i1<=np; i1+=1){
		x = i1*inc;
		for (i2=0; i2<=np; i2+=1){
			phi = i2* inc;
			// write input values to AXI registers
			xc_write(iface, toreg_in1->din, (const unsigned) x); 
			xc_write(iface, toreg_in2->din, (const unsigned) phi);
			xc_write(iface, toreg_in3->din, (const unsigned) y); 
			// Wait for completing the inference process
			for (i=0; i<DELAY; i++);
			// read output data from AXI registers
			xc_read(iface, fromreg1->dout, &bw);
			xc_read(iface, fromreg2->dout, &alpha);
			// Print values of x, phi, y, bw, alpha to standard output
			xil_printf("%d\t%d\t%d\t%d\t%d\n\r", x, phi, y, bw, alpha);
		}
		xil_printf("\n\r");
	}

	//xil_printf("\n\rfinished!....\n\r");

    Xil_ICacheDisable();
    Xil_DCacheDisable();

    return 0;
}


